/*
**                         Copyright 1999 by KVASER AB
**                   P.O Box 4076 SE-51104 KINNAHULT, SWEDEN
**             E-mail: staff@kvaser.se   WWW: http://www.kvaser.se
**
** This software is furnished under a license and may be used and copied
** only in accordance with the terms of such license.
**
** $Header: /SWproj/CKDemo/CKDemoTurin/CKCode.h 4     99-11-15 14:55 Erikl $
** $Revision:: 4    $   $NoKeywords: $
**
** Description:
**
**
*/
//---------------------------------------------------------------------------
#ifndef CKCodeH
#define CKCodeH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <canlib.h>
#include <Grids.hpp>
#include <ComCtrls.hpp>

#define RECEIVE                 0
#define TRANSMIT                1

#define noENVELOPE_ASSIGNED     2048

// Action Modes.
#define ACTION_MODE_KEEP_CURRENT          0
#define ACTION_MODE_RUN                   1
#define ACTION_MODE_FREEZE                2
#define ACTION_MODE_RESET                 3

#define ACTION_MODE_ERROR                 4


// Communication Modes.
#define COMM_MODE_KEEP_CURRENT            0
#define COMM_MODE_SILENT                  1
#define COMM_MODE_LISTEN_ONLY             2
#define COMM_MODE_COMMUNICATE             3

#define COMM_MODE_ERROR                   4

//---------------------------------------------------------------------------

class CKLetter
{
    public:
        unsigned char Transmit_Receive;
        long envelope;
        unsigned char Page[8];
        unsigned int Dlc;
        unsigned int flag;
        unsigned long time;
        __fastcall CKLetter() {memset(Page, 0, 8);};
        __fastcall ~CKLetter() {};
};

//---------------------------------------------------------------------------

class Mayor;

//---------------------------------------------------------------------------

class Folder;

//---------------------------------------------------------------------------

class Document
{
    public:
        Mayor* Local_Mayor;
        char* Name;
        long Envelope;
        virtual void HandlePage(unsigned char* Page);
        __fastcall Document();
        __fastcall ~Document(){};
};
//---------------------------------------------------------------------------

class KingsDocument : public Document
{
    public:
        void HandlePage(unsigned char* Page);

        void __fastcall KingsPage0(unsigned char* Page);
        void __fastcall KingsPage1(unsigned char* Page);
        void __fastcall KingsPage2(unsigned char* Page);
        void __fastcall KingsPage3(unsigned char* Page);
        void __fastcall KingsPage4(unsigned char* Page);
        void __fastcall KingsPage16(unsigned char* Page);

        long __fastcall ExtractEnv(unsigned char* Page);
        Folder* getFolderByFolderNo(unsigned char Folder_No);
        Folder* getFolderByEnvelope(long Envelope);
        __fastcall KingsDocument(){Name = "KingsDoc";};
        __fastcall ~KingsDocument(){};
};
//---------------------------------------------------------------------------

class MayorsDocument : public Document
{
    public:
        void HandlePage(unsigned char* Page);

        __fastcall MayorsDocument(){Name = "MayorDoc";};
        __fastcall ~MayorsDocument(){};

};

//---------------------------------------------------------------------------

class TempSensorDocument : public Document
{
    public:
        void HandlePage(unsigned char* Page);
        TTrackBar* Local_Track_Bar;

        __fastcall TempSensorDocument() {};
        __fastcall ~TempSensorDocument() {};
};

//---------------------------------------------------------------------------

class TempShowDocument : public Document
{
    public:
        void HandlePage(unsigned char* Page);
        TProgressBar* Local_Progress_Bar;

        __fastcall TempShowDocument() {};
        __fastcall ~TempShowDocument() {};
};

//---------------------------------------------------------------------------

class DocumentList
{
    public:
        unsigned char Transmit_Receive;
        unsigned char Max_Record_No;
        Document* Doc[10];
        void __fastcall AddDocument(Document* New_Document);
        void __fastcall RemoveDocument(Document* Old_Document);
};

//---------------------------------------------------------------------------

class Folder
{
    public:
        long Envelope;
        Document *Assigned_Document;
        unsigned char Enable;
        unsigned char Envelope_Enable;
        unsigned char RTR;
        unsigned char Transmit_Receive;
        void __fastcall HandleLetter(CKLetter CK_Letter);
        __fastcall Folder();
        __fastcall ~Folder(){};
};
//----------------------------------------------------------------------------

class PostMaster
{
    private:
        canHandle Handle_To_Opencircuit;

    public:
        unsigned int Channel_Number;
        Mayor *Local_Mayor;
        unsigned char Communication_Mode;

        void __fastcall setCommMode(unsigned char commMode);
        int __fastcall  SetupCan(
                                  HWND Current_Window,
                                  long freq,
                                  unsigned int tseg1,
                                  unsigned int tseg2,
                                  unsigned int sjw,
                                  unsigned int noSamp,
                                  unsigned int syncmode);
        void __fastcall SetDownCan(void);
        void __fastcall ReceiveMessage(void);
        void __fastcall TransmitMessage(CKLetter CK_Letter);

        __fastcall PostMaster(){};
        __fastcall ~PostMaster(){};
};
//------------------------------------------------------------
class Groups
{
    public:
        unsigned char Group[6];
        unsigned char Max_No;
        void __fastcall addGroup(unsigned char newGroup);
        void __fastcall removeGroup(unsigned char OldGroup);
        unsigned char __fastcall findGroup(unsigned char searchGroup);
        __fastcall Groups() {Max_No = 0; memset(Group, 0, 6);};
        __fastcall ~Groups() {};
};

class Mayor
{
    public:
        unsigned char Action_Mode;
        Folder* Local_Folder[6];
        PostMaster *Local_Post_Master;
        Groups Local_Groups;

        DocumentList Transmit_Document_List[1];
        DocumentList Receive_Document_List[1];
        Document* getDocumentByNo(unsigned char Doc_List_No,
                                  unsigned char Doc_Rec_No,
                                  unsigned char Transmit_Receive);

        unsigned char Physical_Address;
        unsigned char Max_Folder_No;
        unsigned char Max_Transmit_List_No;
        unsigned char Max_Receive_List_No;
        int Base_No;

        void __fastcall Reset(void);
        void __fastcall DistributeToFolder(CKLetter CK_Letter);
        void __fastcall setActionMode(unsigned char Act_Mode);
        __fastcall Mayor() {};
        __fastcall ~Mayor() {};
};

//-------------------------------------------------------------

class TCity : public TForm
{
__published:	// IDE-managed Components
    TGroupBox *GroupBox1;
    TLabel *Label1;
    TLabel *Label2;
    TButton *setupButton;
    TEdit *Edit1;
    TComboBox *ChannelCombo;
    TGroupBox *GroupBox2;
    TStringGrid *StringGrid1;
    TGroupBox *GroupBox3;
    TLabel *Label7;
    TLabel *Label8;
    TLabel *Label9;
    TLabel *Label10;
    TTrackBar *TrackBar1;
    TTrackBar *TrackBar2;
    TProgressBar *ProgressBar1;
    TProgressBar *ProgressBar2;
    TGroupBox *GroupBox4;
    TLabel *CommLabel;
    TLabel *ActionLabel;
    TLabel *Label3;
    TLabel *Label4;
    TLabel *Label11;
    TStringGrid *StringGrid2;
    TLabel *BaseNoLabel;
        TButton *Button1;
    void __fastcall InitiateStringGrid1(void);
    void __fastcall UpDateStringGrid1(void);
    void __fastcall ShowError(char* text, canStatus Stat);
    void __fastcall OnCKLetter(TMessage &Message);
    void __fastcall setupButtonClick(TObject *Sender);
    void __fastcall TrackBar1Change(TObject *Sender);
    void __fastcall TrackBar2Change(TObject *Sender);
    void __fastcall FormShow(TObject *Sender);
        void __fastcall Button1Click(TObject *Sender);

    private:	// User declarations
        Mayor Local_Mayor;
        PostMaster Local_Post_Master;

        KingsDocument Kings_Document;
        MayorsDocument Mayors_Document;
        TempSensorDocument Temp_Sensor_Document_1;
        TempSensorDocument Temp_Sensor_Document_2;
        TempShowDocument Temp_Show_Document_1;
        TempShowDocument Temp_Show_Document_2;

        Folder Local_Folder[6];

        BEGIN_MESSAGE_MAP
            MESSAGE_HANDLER(WM__CANLIB, TMessage, OnCKLetter)
        END_MESSAGE_MAP(TForm)

    public:		// User declarations
            __fastcall TCity(TComponent* Owner);
};

//---------------------------------------------------------------------------
extern PACKAGE TCity *City;
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
#endif

