//---------------------------------------------------------------------------
#ifndef CKDemoTurinH
#define CKDemoTurinH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <canlib.h>
#include <Grids.hpp>
#include <ComCtrls.hpp>


#define RECIVE            0
#define TRANSMIT          1

#define noENVELOPE_ASSIGNED     2032

#define COMMUNICATE             3

//---------------------------------------------------------------------------

class CanMessage
{
public:
  unsigned char Transmit_Recive;
  long id;
  unsigned char Page[8];
  unsigned int dlc;
  unsigned int flag;
  unsigned long time;
  __fastcall CanMessage(){Page[0] = 0; Page[1] = 0; Page[2] = 0; Page[3] = 0; Page[4] = 0; Page[5] = 0; Page[6] = 0; Page[7] = 0;};
  __fastcall ~CanMessage(){};
};

//---------------------------------------------------------------------------

class Document;
//-------------------------------------------------------------

class Folder
{
public:
  long Envelope;
  Document *Assigned_Document;
  unsigned char Enable;
  unsigned char Envelope_Enable;
  unsigned char RTR;
  unsigned char Transmit_Recive;
  unsigned char Dlc;

//  int Document_List_Number;
//  int Document_Number;
//  int Can_Control_Field;
//  int Remote_Envelope;
//  int Enable_Disable_Folder;
//  int Envelopes_Disable;

  __fastcall Folder();
  __fastcall ~Folder(){};
};
//-------------------------------------------------------------

class Mayor;
//-------------------------------------------------------------

class LineOrBitForm
{
public:
  unsigned char Start_Pos;
  unsigned char Size;
  Mayor* Local_Mayor;
  char* Name;
  unsigned char* ToggleFormat(unsigned char* Page);

  virtual void ActOnInput(unsigned char* Input){};
  __fastcall LineOrBitForm(){Name = "";};
  __fastcall ~LineOrBitForm(){};
};

//---------------------------------------------------------------------------
class LineOrBitFormList
{
public:
  unsigned char Transmit_Recive;
  unsigned char Max_Record_No;
  LineOrBitForm* Line_Or_Bit_Form[10];
  __fastcall LineOrBitFormList(){};
  __fastcall ~LineOrBitFormList(){};
};

//---------------------------------------------------------------------------
class PageForm
{
public:
  LineOrBitForm* Local_Line_Or_Bit[10];
  char* Name;
  virtual void HandleLineOrBit(unsigned char* Line_Or_Bit){};
  __fastcall PageForm(){};
  __fastcall ~PageForm(){};
};
//---------------------------------------------------------------------------

class PageFormList
{
public:
  unsigned char Transmit_Recive;
  unsigned char Max_Record_No;
  PageForm* PageForm[10];
  __fastcall PageFormList(){};
  __fastcall ~PageFormList(){};
};
//---------------------------------------------------------------------------

class Document
{
public:
  Mayor* Local_Mayor;
  PageForm* Local_Form[10];
  char* Name;
  long Envelope;
  virtual void HandlePage(unsigned char* Page);
  __fastcall Document(){Envelope = noENVELOPE_ASSIGNED;};
  __fastcall ~Document(){};
};
//---------------------------------------------------------------------------




class DocumentList
{
public:
  unsigned char Transmit_Recive;
  unsigned char Max_Record_No;
  Document* Doc[10];
  void __fastcall AddDocument(Document* New_Document);
  void __fastcall RemoveDocument(Document* Old_Document);
};

//---------------------------------------------------------------------------

class Filter
{
public:
  long Disabled_Envelopes[20];
  void __fastcall AddEnvelope(long Envelope);
  void __fastcall RemoveEnvelope(long Envelope);
  bool __fastcall doFilter(long Envelope);
  int __fastcall FindEnvelope(long Envelope);

  __fastcall Filter(){Disabled_Envelopes[0] = noENVELOPE_ASSIGNED; Disabled_Envelopes[1] = -1;};
  __fastcall ~Filter(){};
};
//------------------------------------------------------------

class PostMaster
{
private:
  canHandle Handle_To_Opencircuit;

public:
  Filter Filter1;
  unsigned int Channel_Number;
  Mayor *Local_Mayor;
  unsigned char Communication_Mode;

  void __fastcall setMode(unsigned char commMode);
  void __fastcall  SetupCan(
                HWND Current_Window,
                long freq,
                unsigned int tseg1,
		unsigned int tseg2,
		unsigned int sjw,
		unsigned int noSamp,
		unsigned int syncmode);
  void __fastcall SetDownCan(void);
  void __fastcall ReciveMessage();
  void __fastcall TransmitMessage(CanMessage Can_Message);

  __fastcall PostMaster(){Communication_Mode = 2;};
  __fastcall ~PostMaster(){};
};
//------------------------------------------------------------

class Mayor
{
public:
  Folder* Local_Folder[4];
  PostMaster *Local_Post_Master;

  DocumentList Transmit_Document_List[1];
  DocumentList Recive_Document_List[1];
  Document* getDocumentByNo(unsigned char Doc_List_No, unsigned char Doc_Rec_No, unsigned char Transmit_Recive);

  PageFormList Transmit__Page_Form_List[1];
  PageFormList Recive_Page_Form_List[1];

  LineOrBitFormList Transmit_Line_Form_List[10];


  unsigned char Physical_Address;
  unsigned char Max_Folder_No;
  unsigned char Max_Transmit_List_No;
  unsigned char Max_Recive_List_No;

  void __fastcall HandleMessage(CanMessage Can_Message);

  __fastcall Mayor(){};
  __fastcall ~Mayor(){};
};
//-------------------------------------------------------------

class KingsDocument : public Document
{
public:
  void HandlePage(unsigned char* Page);

  void __fastcall KingsPage0(unsigned char* Page);
  void __fastcall KingsPage1(unsigned char* Page);
  void __fastcall KingsPage2(unsigned char* Page);
  void __fastcall KingsPage16(unsigned char* Page);
  void __fastcall KingsPage17(unsigned char* Page);

  long __fastcall ExtractEnv(unsigned char* Page);
  Folder* getFolderByFolderNo(unsigned char Folder_No);
  Folder* getFolderByEnvelope(long Envelope);
  __fastcall KingsDocument(){Name = "KingsDoc";};
  __fastcall ~KingsDocument(){};
};
//---------------------------------------------------------------------------

class MayorsDocument : public Document
{
public:
  void HandlePage(unsigned char* Page);

  __fastcall MayorsDocument(){Name = "MayorDoc";};
  __fastcall ~MayorsDocument(){};

};

//---------------------------------------------------------------------------

class TempSensorDocument : public Document
{
public:
  void HandlePage(unsigned char* Page);
  TTrackBar* Local_Track_Bar;

  __fastcall TempSensorDocument(){Name = "SensorDoc";};
  __fastcall ~TempSensorDocument(){};
};
//---------------------------------------------------------------------------


class TempShowDocument : public Document
{
public:
  void HandlePage(unsigned char* Page);
  TProgressBar* Local_Progress_Bar;

  __fastcall TempShowDocument(){Name = "ShowDoc";};
  __fastcall ~TempShowDocument(){};
};

//-------------------------------------------------------------

class GenericDocument : public Document
{
public:
  void HandlePage(unsigned char* Page);
  PageForm* Assigned_Page_Form[20];
  unsigned char Max_Form_No;
};

//---------------------------------------------------------------------------

class GenericPageForm : public PageForm
{
public:
  void HandleLineOrBit(unsigned char* Page);
  LineOrBitForm* Assigned_Bit_Or_Line[8];
  unsigned char Max_Bit_Or_Line_No;
};

//---------------------------------------------------------------------------


class Show_1000_Resolution : public LineOrBitForm
{
public:
  void ActOnInput(unsigned char* Input);
};

//---------------------------------------------------------------------------

class TCity : public TForm
{
__published:	// IDE-managed Components
        TButton *setupButton;
        TButton *setDownButton;
        TLabel *Label1;
        TTrackBar *TrackBar1;
        TTrackBar *TrackBar2;
        TProgressBar *ProgressBar1;
        TProgressBar *ProgressBar2;
        TEdit *Edit1;
        TLabel *Label2;
        TEdit *Edit2;
        TStringGrid *StringGrid1;
        void __fastcall UpDateStringGrid1(void);
        void __fastcall ShowError(canStatus Stat);
        void __fastcall setDownButtonClick(TObject *Sender);
        void __fastcall OnCanMessage(TMessage &Message);
        void __fastcall setupButtonClick(TObject *Sender);
        void __fastcall TrackBar1Change(TObject *Sender);
        void __fastcall TrackBar2Change(TObject *Sender);

private:	// User declarations

        Mayor Local_Mayor;
        PostMaster Local_Post_Master;

        KingsDocument Kings_Document;
        MayorsDocument Mayors_Document;
        TempSensorDocument Temp_Sensor_Document_1;
        TempSensorDocument Temp_Sensor_Document_2;
        TempShowDocument Temp_Show_Document_1;
        TempShowDocument Temp_Show_Document_2;

        Folder Local_Folder[4];

        unsigned char actMode;

BEGIN_MESSAGE_MAP
  MESSAGE_HANDLER(WM__CANLIB, TMessage, OnCanMessage)
END_MESSAGE_MAP(TForm)

public:		// User declarations
        __fastcall TCity(TComponent* Owner);
};

//---------------------------------------------------------------------------
extern PACKAGE TCity *City;
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
#endif

